%% Script that compares the cost of balancing in the balancing market
% The wind error forecast and balancing price is
% stochastic and the price in Elbas is known.
%% Finding the price of Elbas using 2012 values
[ElbasDiff]=xlsread('Elbasonehour.xlsm','Sheet1','A2:A7160');
BalPriceRK = zeros(7159,1);
% Starting the loop
nsamples = 1000;
for l = 1:nsamples
%% Draw the wind error based on the found parameters
% mean = 0.7335, sd = 11.4384

WindError =zeros(7159,1);
for j=1:7159
WindError(j)=normrnd(0.7335,11.4384);
end
%Including the remaining error in the last hour after gate closure


for i = 1:7159
    if (mod(i,24)>9 && mod(i,24)<23)
      %dag 
      BalPriceRK(i)= 0.3335*wblrnd(7.1757,1.0298) + 0.47814*wblrnd(9.0485,1.4831)*(-1);
      
    else
      %natt
      BalPriceRK(i)= 0.2856*wblrnd(7.1757,1.0298) + 0.4511*wblrnd(9.0485,1.4831)*(-1);
    end
 end
Check = (WindError.*BalPriceRK <0);

%% Finding the price of Elbas using 2012 values
BalCostsHourlyElb=0.82.*WindError.*ElbasDiff+0.18.*WindError.*BalPriceRK.*Check;
SumBalCostsHourlyElb(l)=sum(BalCostsHourlyElb);

%% Finding the price of Elbas using Normal distribution with mean = 0.0874, var = 0.0617
%ElbasDiffMod = zeros(8784,1);
%for m = 1:8784
%ElbasDiffMod(m) = normrnd(-0.2302,7.4199);
%end
%BalCostsHourlyElbMod=WindError.*ElbasDiffMod;
%SumBalCostsHourlyElbMod(l)=sum(BalCostsHourlyElbMod);


end
figure

hist(SumBalCostsHourlyElb,100)
%title('Actual Elbas Prices from 2012')
mean(SumBalCostsHourlyElb)
var(SumBalCostsHourlyElb)

SortedElbasActual=sort(SumBalCostsHourlyElb);
figure
plot(SortedElbasActual)
%title('Sorted Costs in Elbas using 2012 data')

%figure
%hist(SumBalCostsHourlyElbMod,100)
%title('Modeled Elbas Prices')
%mean(SumBalCostsHourlyElbMod)
%var(SumBalCostsHourlyElbMod)