%% Script that compares the cost of balancing in the balancing market
% The wind error forecast and balancing price is
% stochastic and the price in Elbas is known.

% Starting the loop
nsamples = 1000;
for l = 1:nsamples
%% Draw the wind error based on the found parameters
% mean = 0.7335, sd = 11.4384

WindError =zeros(8784,1);
for j=1:8784
WindError(j)=normrnd(0.7335,11.4384);
end

%% Find the price of balancing in the balancing market.
% Parameters found in R, uses the average price whit probobility wheighted
% direction.
BalPriceRK = zeros(8784,1);

for i = 1:8784
    if (mod(i,24)>9 && mod(i,24)<23)
      %dag 
      BalPriceRK(i)= 0.3335*wblrnd(7.1757,1.0298) + 0.47814*wblrnd(9.0485,1.4831)*(-1);
      
    else
      %natt
      BalPriceRK(i)= 0.2856*wblrnd(7.1757,1.0298) + 0.4511*wblrnd(9.0485,1.4831)*(-1);
    end
 end
 
Check = (WindError.*BalPriceRK <0);
BalCostsHourly = WindError.*BalPriceRK.*Check;
SumBalCostsHourly(l) = sum(BalCostsHourly);
end

SortertBalCosts=sort(SumBalCostsHourly,'ascend')
figure
plot(SortertBalCosts)
%title('Sorted Balancing costs in the balancing market')

figure
hist(SumBalCostsHourly,100)
mean(SumBalCostsHourly)
var(SumBalCostsHourly)
%title('Histogram of Balancing costs in the balancing market')
 